blob: 86d30d526fd0c5417dfc3849ae7197a5417275a4 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010044export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010059 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070060fi
61
Orion Hodson64fe3be2018-06-15 12:50:22 +010062export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070063
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Dan Willemsen12371e92017-03-06 17:55:20 -080079# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
80# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
81export OUT_DIR=${OUT_DIR:-out}
82if [[ "$OUT_DIR" != /* ]]; then
83 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
84fi
85
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086# ANDROID_HOST_OUT is not set in a build environment.
87if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080088 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089fi
90
Alex Light680cbf22018-10-31 11:00:19 -070091host_lib_root=${ANDROID_HOST_OUT}
92
Igor Murashkine5181932017-06-15 16:03:50 -070093# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070094if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070095 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
96fi
97
Igor Murashkin271a0f82017-02-14 21:14:17 +000098# Zipalign is not on the PATH in some configs, auto-detect it.
99if [ -z "$ZIPALIGN" ]; then
100 if which zipalign >/dev/null; then
101 ZIPALIGN="zipalign";
102 else
103 # TODO: Add a dependency for zipalign in Android.run-test.mk
104 # once it doesn't depend on libandroidfw (b/35246701)
105 case "$OSTYPE" in
106 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
107 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
108 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
109 esac
110 fi
111fi
112export ZIPALIGN
113
David Brazdil122c6632018-01-24 17:32:49 +0000114# If hiddenapi was not set by the environment variable, assume it is in
115# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000116if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000117 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000118fi
119
Roland Levillain76cfe612017-10-30 13:14:28 +0000120chroot=
121
jeffhao5d1ac922011-09-29 17:41:15 -0700122info="info.txt"
123build="build"
124run="run"
125expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700126check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700127output="output.txt"
128build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100129cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700130strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700131lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700132testlib="arttestd"
Andreas Gampe11410de2019-07-02 15:53:53 -0700133run_args=(--quiet)
David Brazdil4846d132015-01-15 19:07:08 +0000134build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700135
Alex Light91de25f2015-10-28 17:00:06 -0700136quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000137debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700138prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700139target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700140dev_mode="no"
Alex Light8d94ddd2019-12-18 11:13:03 -0800141create_runner="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700142update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700143debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000144relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800145runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700146usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700147build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700148suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700149trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700150trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700151basic_verify="false"
152gc_verify="false"
153gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700154jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700155jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700156jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700157jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700158strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700159always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700160never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700161have_image="yes"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000162android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700163bisection_search="no"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100164timeout=""
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800165suspend_timeout="500000"
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100166run_optimizing="false"
jeffhao5d1ac922011-09-29 17:41:15 -0700167
Alex Light20802ca2018-12-05 15:36:03 -0800168# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
169# ART output to approximately 128MB. This should be more than sufficient
170# for any test while still catching cases of runaway output.
171# Set a hard limit to encourage ART developers to increase the ulimit here if
172# needed to support a test case rather than resetting the limit in the run
173# script for the particular test in question. Adjust this if needed for
174# particular configurations.
175file_ulimit=128000
176
Andreas Gampe11410de2019-07-02 15:53:53 -0700177
jeffhao5d1ac922011-09-29 17:41:15 -0700178while true; do
179 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700180 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700181 DEX_LOCATION=$tmp_dir
Andreas Gampe11410de2019-07-02 15:53:53 -0700182 run_args+=(--host)
jeffhao5d1ac922011-09-29 17:41:15 -0700183 shift
Alex Light91de25f2015-10-28 17:00:06 -0700184 elif [ "x$1" = "x--quiet" ]; then
185 quiet="yes"
186 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700187 elif [ "x$1" = "x--use-java-home" ]; then
188 if [ -n "${JAVA_HOME}" ]; then
189 export JAVA="${JAVA_HOME}/bin/java"
190 export JAVAC="${JAVA_HOME}/bin/javac -g"
191 else
192 echo "Passed --use-java-home without JAVA_HOME variable set!"
193 usage="yes"
194 fi
195 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800196 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700197 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800198 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800199 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700200 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700201 NEED_DEX="false"
Andreas Gampe11410de2019-07-02 15:53:53 -0700202 run_args+=(--jvm)
jeffhao5d1ac922011-09-29 17:41:15 -0700203 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800204 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700205 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700206 testlib="arttest"
Andreas Gampe11410de2019-07-02 15:53:53 -0700207 run_args+=(-O)
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700208 shift
209 elif [ "x$1" = "x--dalvik" ]; then
210 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800211 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700212 shift
Alex Light03a112d2014-08-25 13:25:56 -0700213 elif [ "x$1" = "x--no-image" ]; then
214 have_image="no"
215 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700216 elif [ "x$1" = "x--relocate" ]; then
217 relocate="yes"
218 shift
219 elif [ "x$1" = "x--no-relocate" ]; then
220 relocate="no"
221 shift
222 elif [ "x$1" = "x--prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700223 run_args+=(--prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700224 prebuild_mode="yes"
225 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800226 elif [ "x$1" = "x--compact-dex-level" ]; then
227 option="$1"
228 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700229 run_args+=("$option" "$1")
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800230 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700231 elif [ "x$1" = "x--strip-dex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700232 run_args+=(--strip-dex)
Richard Uhler76f5cb62016-04-04 13:30:16 -0700233 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000234 elif [ "x$1" = "x--debuggable" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700235 run_args+=(-Xcompiler-option --debuggable)
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000236 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000237 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700238 elif [ "x$1" = "x--no-prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700239 run_args+=(--no-prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700240 prebuild_mode="no"
241 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700242 elif [ "x$1" = "x--gcverify" ]; then
243 basic_verify="true"
244 gc_verify="true"
245 shift
246 elif [ "x$1" = "x--gcstress" ]; then
247 basic_verify="true"
248 gc_stress="true"
249 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700250 elif [ "x$1" = "x--jvmti-step-stress" ]; then
251 jvmti_step_stress="true"
252 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700253 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
254 jvmti_redefine_stress="true"
255 shift
Alex Light43e935d2017-06-19 15:40:40 -0700256 elif [ "x$1" = "x--jvmti-field-stress" ]; then
257 jvmti_field_stress="true"
258 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700259 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
260 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700261 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800262 elif [ "x$1" = "x--suspend-timeout" ]; then
263 shift
264 suspend_timeout="$1"
265 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700266 elif [ "x$1" = "x--image" ]; then
267 shift
268 image="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700269 run_args+=(--image "$image")
Elliott Hughes7c046102011-10-19 18:16:03 -0700270 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000271 elif [ "x$1" = "x-Xcompiler-option" ]; then
272 shift
273 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700274 run_args+=(-Xcompiler-option "$option")
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000275 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000276 elif [ "x$1" = "x--build-option" ]; then
277 shift
278 option="$1"
279 build_args="${build_args} $option"
280 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700281 elif [ "x$1" = "x--runtime-option" ]; then
282 shift
283 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700284 run_args+=(--runtime-option "$option")
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700285 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700286 elif [ "x$1" = "x--gdb-arg" ]; then
287 shift
288 gdb_arg="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700289 run_args+=(--gdb-arg "$gdb_arg")
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700290 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700291 elif [ "x$1" = "x--debug" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700292 run_args+=(--debug)
jeffhao5d1ac922011-09-29 17:41:15 -0700293 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700294 elif [ "x$1" = "x--debug-wrap-agent" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700295 run_args+=(--debug-wrap-agent)
Alex Lightc281ba52017-10-11 11:35:55 -0700296 shift
Alex Light0e151e72017-10-25 10:50:35 -0700297 elif [ "x$1" = "x--with-agent" ]; then
298 shift
299 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700300 run_args+=(--with-agent "$1")
Alex Light0e151e72017-10-25 10:50:35 -0700301 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700302 elif [ "x$1" = "x--debug-agent" ]; then
303 shift
304 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700305 run_args+=(--debug-agent "$1")
Alex Lightc281ba52017-10-11 11:35:55 -0700306 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700307 elif [ "x$1" = "x--gdb" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700308 run_args+=(--gdb)
jeffhao5d1ac922011-09-29 17:41:15 -0700309 dev_mode="yes"
310 shift
Alex Lighte4b4a182019-02-12 14:19:49 -0800311 elif [ "x$1" = "x--gdbserver-bin" ]; then
312 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700313 run_args+=(--gdbserver-bin "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800314 shift
315 elif [ "x$1" = "x--gdbserver-port" ]; then
316 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700317 run_args+=(--gdbserver-port "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800318 shift
319 elif [ "x$1" = "x--gdbserver" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700320 run_args+=(--gdbserver)
Alex Lighte4b4a182019-02-12 14:19:49 -0800321 dev_mode="yes"
322 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700323 elif [ "x$1" = "x--strace" ]; then
324 strace="yes"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100325 run_args+=(--invoke-with strace --invoke-with -o --invoke-with "$tmp_dir/$strace_output")
326 timeout="${timeout:-1800}"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700327 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700328 elif [ "x$1" = "x--zygote" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700329 run_args+=(--zygote)
jeffhao5d1ac922011-09-29 17:41:15 -0700330 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800331 elif [ "x$1" = "x--interpreter" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700332 run_args+=(--interpreter)
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700333 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800334 elif [ "x$1" = "x--jit" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700335 run_args+=(--jit)
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800336 shift
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100337 elif [ "x$1" = "x--baseline" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700338 run_args+=(--baseline)
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100339 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700340 elif [ "x$1" = "x--optimizing" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100341 run_optimizing="true"
jeffhao0dff3f42012-11-20 15:13:43 -0800342 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700343 elif [ "x$1" = "x--no-verify" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700344 run_args+=(--no-verify)
jeffhao5d1ac922011-09-29 17:41:15 -0700345 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700346 elif [ "x$1" = "x--verify-soft-fail" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700347 run_args+=(--verify-soft-fail)
Igor Murashkin7617abd2015-07-10 18:27:47 -0700348 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700349 elif [ "x$1" = "x--no-optimize" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700350 run_args+=(--no-optimize)
jeffhao5d1ac922011-09-29 17:41:15 -0700351 shift
352 elif [ "x$1" = "x--no-precise" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700353 run_args+=(--no-precise)
jeffhao5d1ac922011-09-29 17:41:15 -0700354 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700355 elif [ "x$1" = "x--invoke-with" ]; then
356 shift
357 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700358 if [ "x$what" = "x" ]; then
359 echo "$0 missing argument to --invoke-with" 1>&2
360 usage="yes"
361 break
362 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700363 run_args+=(--invoke-with "${what}")
jeffhao5d1ac922011-09-29 17:41:15 -0700364 shift
Alex Light8d94ddd2019-12-18 11:13:03 -0800365 elif [ "x$1" = "x--create-runner" ]; then
366 run_args+=(--create-runner --dry-run)
367 dev_mode="yes"
368 never_clean="yes"
369 create_runner="yes"
370 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700371 elif [ "x$1" = "x--dev" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700372 run_args+=(--dev)
jeffhao5d1ac922011-09-29 17:41:15 -0700373 dev_mode="yes"
374 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700375 elif [ "x$1" = "x--build-only" ]; then
376 build_only="yes"
377 shift
378 elif [ "x$1" = "x--output-path" ]; then
379 shift
380 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700381 if [ "x$tmp_dir" = "x" ]; then
382 echo "$0 missing argument to --output-path" 1>&2
383 usage="yes"
384 break
385 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700386 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000387 elif [ "x$1" = "x--chroot" ]; then
388 shift
389 if [ "x$1" = "x" ]; then
390 echo "$0 missing argument to --chroot" 1>&2
391 usage="yes"
392 break
393 fi
394 chroot="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700395 run_args+=(--chroot "$1")
Roland Levillain76cfe612017-10-30 13:14:28 +0000396 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000397 elif [ "x$1" = "x--android-root" ]; then
398 shift
399 if [ "x$1" = "x" ]; then
400 echo "$0 missing argument to --android-root" 1>&2
401 usage="yes"
402 break
403 fi
404 android_root="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700405 run_args+=(--android-root "$1")
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000406 shift
Martin Stjernholme58624f2019-09-20 15:53:40 +0100407 elif [ "x$1" = "x--android-art-root" ]; then
Roland Levillain28076142019-01-10 16:39:25 +0000408 shift
409 if [ "x$1" = "x" ]; then
Martin Stjernholme58624f2019-09-20 15:53:40 +0100410 echo "$0 missing argument to --android-art-root" 1>&2
Roland Levillain28076142019-01-10 16:39:25 +0000411 usage="yes"
412 break
413 fi
Martin Stjernholme58624f2019-09-20 15:53:40 +0100414 run_args+=(--android-art-root "$1")
Roland Levillain28076142019-01-10 16:39:25 +0000415 shift
Roland Levillain90b34572019-06-14 15:23:15 +0100416 elif [ "x$1" = "x--android-tzdata-root" ]; then
417 shift
418 if [ "x$1" = "x" ]; then
419 echo "$0 missing argument to --android-tzdata-root" 1>&2
420 usage="yes"
421 break
422 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700423 run_args+=(--android-tzdata-root "$1")
Roland Levillain90b34572019-06-14 15:23:15 +0100424 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700425 elif [ "x$1" = "x--update" ]; then
426 update_mode="yes"
427 shift
428 elif [ "x$1" = "x--help" ]; then
429 usage="yes"
430 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700431 elif [ "x$1" = "x--64" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700432 run_args+=(--64)
Andreas Gampe2fe07922014-04-21 07:50:39 -0700433 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700434 shift
Alex Light680cbf22018-10-31 11:00:19 -0700435 elif [ "x$1" = "x--bionic" ]; then
436 # soong linux_bionic builds are 64bit only.
Andreas Gampe11410de2019-07-02 15:53:53 -0700437 run_args+=(--bionic --host --64)
Alex Light680cbf22018-10-31 11:00:19 -0700438 suffix64="64"
439 target_mode="no"
440 DEX_LOCATION=$tmp_dir
441 host_lib_root=$OUT_DIR/soong/host/linux_bionic-x86
442 shift
Alex Light6f342dd2019-03-27 17:15:42 +0000443 elif [ "x$1" = "x--runtime-extracted-zipapex" ]; then
444 shift
445 # TODO Should we allow the java.library.path to search the zipapex too?
446 # Not needed at the moment and adding it will be complicated so for now
447 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700448 run_args+=(--host --runtime-extracted-zipapex "$1")
Alex Light6f342dd2019-03-27 17:15:42 +0000449 target_mode="no"
450 DEX_LOCATION=$tmp_dir
451 shift
Alex Light20802ca2018-12-05 15:36:03 -0800452 elif [ "x$1" = "x--runtime-zipapex" ]; then
453 shift
454 # TODO Should we allow the java.library.path to search the zipapex too?
455 # Not needed at the moment and adding it will be complicated so for now
456 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700457 run_args+=(--host --runtime-zipapex "$1")
Alex Light20802ca2018-12-05 15:36:03 -0800458 target_mode="no"
459 DEX_LOCATION=$tmp_dir
460 # apex_payload.zip is quite large we need a high enough ulimit to
461 # extract it. 512mb should be good enough.
462 file_ulimit=512000
463 shift
Martin Stjernholm4815e722019-09-24 16:20:09 +0100464 elif [ "x$1" = "x--timeout" ]; then
465 shift
466 if [ "x$1" = "x" ]; then
467 echo "$0 missing argument to --timeout" 1>&2
468 usage="yes"
469 break
470 fi
471 timeout="$1"
472 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200473 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700474 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200475 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700476 elif [ "x$1" = "x--stream" ]; then
477 trace_stream="true"
478 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700479 elif [ "x$1" = "x--always-clean" ]; then
480 always_clean="yes"
481 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700482 elif [ "x$1" = "x--never-clean" ]; then
483 never_clean="yes"
484 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800485 elif [ "x$1" = "x--dex2oat-swap" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700486 run_args+=(--dex2oat-swap)
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800487 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700488 elif [ "x$1" = "x--instruction-set-features" ]; then
489 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700490 run_args+=(--instruction-set-features "$1")
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700491 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700492 elif [ "x$1" = "x--bisection-search" ]; then
493 bisection_search="yes"
494 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000495 elif [ "x$1" = "x--vdex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700496 run_args+=(--vdex)
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000497 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000498 elif [ "x$1" = "x--dm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700499 run_args+=(--dm)
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000500 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000501 elif [ "x$1" = "x--vdex-filter" ]; then
502 shift
503 filter=$1
Andreas Gampe11410de2019-07-02 15:53:53 -0700504 run_args+=(--vdex-filter "$filter")
Nicolas Geoffray74981052017-01-16 17:54:09 +0000505 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700506 elif [ "x$1" = "x--random-profile" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700507 run_args+=(--random-profile)
Jeff Hao002b9312017-03-27 16:23:08 -0700508 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700509 elif [ "x$1" = "x--dex2oat-jobs" ]; then
510 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700511 run_args+=(-Xcompiler-option "-j$1")
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700512 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700513 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700514 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700515 usage="yes"
516 break
517 else
518 break
519 fi
520done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700521
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100522if [ "$usage" = "no" -a "x$1" = "x" ]; then
523 echo "missing test to run" 1>&2
524 usage="yes"
525fi
526
Roland Levillain76cfe612017-10-30 13:14:28 +0000527# The DEX_LOCATION with the chroot prefix, if any.
528chroot_dex_location="$chroot$DEX_LOCATION"
529
Alex Light91de25f2015-10-28 17:00:06 -0700530# Allocate file descriptor real_stderr and redirect it to the shell's error
531# output (fd 2).
532if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
533 exec {real_stderr}>&2
534else
535 # In bash before version 4.1 we need to do a manual search for free file
536 # descriptors.
537 FD=3
538 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
539 real_stderr=$FD
540 eval "exec ${real_stderr}>&2"
541fi
542if [ "$quiet" = "yes" ]; then
543 # Force the default standard output and error to go to /dev/null so we will
544 # not print them.
545 exec 1>/dev/null
546 exec 2>/dev/null
547fi
548
549function err_echo() {
550 echo "$@" 1>&${real_stderr}
551}
552
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700553# tmp_dir may be relative, resolve.
554#
555# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000556# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700557# Cannot use readlink -m, as it does not exist on Mac.
558# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700559noncanonical_tmp_dir=$tmp_dir
Andreas Gampe86459c02019-08-29 14:01:18 -0700560tmp_dir="`cd $oldwd ; python -c "import os; import sys; sys.stdout.write(os.path.realpath('$tmp_dir'))"`"
561if [ -z $tmp_dir ] ; then
562 err_echo "Failed to resolve $tmp_dir"
563 exit 1
564fi
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700565mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700566
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800567# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000568if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700569 run_args+=(--runtime-option "-XX:ThreadSuspendTimeout=$suspend_timeout")
Narayan Kamathf86c3932017-01-24 17:40:47 +0000570fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800571
Alex Lighte7873ec2014-08-12 09:53:50 -0700572if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800573 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
Andreas Gampe11410de2019-07-02 15:53:53 -0700574 run_args+=(--runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0)
Alex Lighte7873ec2014-08-12 09:53:50 -0700575fi
576if [ "$gc_verify" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700577 run_args+=(--runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc)
Alex Lighte7873ec2014-08-12 09:53:50 -0700578fi
579if [ "$gc_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700580 run_args+=(--gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m)
Alex Lighte7873ec2014-08-12 09:53:50 -0700581fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700582if [ "$jvmti_redefine_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700583 run_args+=(--no-app-image --jvmti-redefine-stress)
Alex Lightb7edcda2017-04-27 13:20:31 -0700584fi
Alex Lightc38c3692017-06-27 15:45:14 -0700585if [ "$jvmti_step_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700586 run_args+=(--no-app-image --jvmti-step-stress)
Alex Lightc38c3692017-06-27 15:45:14 -0700587fi
Alex Light43e935d2017-06-19 15:40:40 -0700588if [ "$jvmti_field_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700589 run_args+=(--no-app-image --jvmti-field-stress)
Alex Light43e935d2017-06-19 15:40:40 -0700590fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700591if [ "$jvmti_trace_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700592 run_args+=(--no-app-image --jvmti-trace-stress)
Alex Light8f2c6d42017-04-10 16:27:35 -0700593fi
Jeff Hao85139a32014-07-23 11:52:52 -0700594if [ "$trace" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700595 run_args+=(--runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000)
Andreas Gampe7526d782015-06-22 22:53:45 -0700596 if [ "$trace_stream" = "true" ]; then
597 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
598 # the ability to analyze the file and just write to /dev/null.
Andreas Gampe11410de2019-07-02 15:53:53 -0700599 run_args+=(--runtime-option -Xmethod-trace-file:/dev/null)
Andreas Gampe7526d782015-06-22 22:53:45 -0700600 # Enable streaming mode.
Andreas Gampe11410de2019-07-02 15:53:53 -0700601 run_args+=(--runtime-option -Xmethod-trace-stream)
Andreas Gampe7526d782015-06-22 22:53:45 -0700602 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700603 run_args+=(--runtime-option "-Xmethod-trace-file:${DEX_LOCATION}/trace.bin")
Andreas Gampe7526d782015-06-22 22:53:45 -0700604 fi
605elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700606 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700607 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700608fi
Martin Stjernholm4815e722019-09-24 16:20:09 +0100609if [ -n "$timeout" ]; then
610 run_args+=(--timeout "$timeout")
611fi
Jeff Hao85139a32014-07-23 11:52:52 -0700612
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700613# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000614# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100615function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700616 # Check whether this is a device with native bridge. Currently this is hardcoded
617 # to x86 + arm.
David Srbecky928d28e2020-04-01 17:50:51 +0100618 local guess_path=${ANDROID_PRODUCT_OUT}/system/apex/com.android.art.testing/javalib
619 local x86_arm=`ls ${guess_path} | sort | grep -E '^(arm|x86)$'`
Andreas Gamped0566d42018-06-06 09:54:34 -0700620 # Collapse line-breaks into spaces
621 x86_arm=$(echo $x86_arm)
622 if [ "x$x86_arm" = "xarm x86" ] ; then
623 err_echo "Native-bridge configuration detected."
624 # We only support the main arch for tests.
625 if [ "x${suffix64}" = "x64" ]; then
626 target_arch_name=""
627 else
628 target_arch_name=x86
629 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700630 else
David Srbecky928d28e2020-04-01 17:50:51 +0100631 local grep32bit=`ls ${guess_path} | grep -E '^(arm|x86)$'`
632 local grep64bit=`ls ${guess_path} | grep -E '^(arm64|x86_64)$'`
Andreas Gamped0566d42018-06-06 09:54:34 -0700633 if [ "x${suffix64}" = "x64" ]; then
634 target_arch_name=${grep64bit}
635 else
636 target_arch_name=${grep32bit}
637 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700638 fi
639}
640
David Brazdil853a4c32015-09-28 16:15:50 +0100641function guess_host_arch_name() {
642 if [ "x${suffix64}" = "x64" ]; then
643 host_arch_name="x86_64"
644 else
645 host_arch_name="x86"
646 fi
647}
648
Alex Lighta59dd802014-07-02 16:28:08 -0700649if [ "$target_mode" = "no" ]; then
650 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700651 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700652 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000653 exit 1
654 fi
655 else
656 # ART/Dalvik host mode.
657 if [ -n "$chroot" ]; then
658 err_echo "--chroot with --host is unsupported"
659 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700660 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700661 fi
662fi
663
Jeff Hao201803f2013-11-20 18:11:39 -0800664if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700665 run_args+=(--lib "$lib")
Jeff Hao201803f2013-11-20 18:11:39 -0800666fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700667
Jeff Hao201803f2013-11-20 18:11:39 -0800668if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700669 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000670 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Victor Chang759845f2019-08-06 16:04:36 +0100671 bpath="${framework}/core-icu4j.jar:${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Andreas Gampe11410de2019-07-02 15:53:53 -0700672 run_args+=(--boot --runtime-option "-Xbootclasspath:${bpath}")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700673 else
674 true # defaults to using target BOOTCLASSPATH
675 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800676elif [ "$runtime" = "art" ]; then
Ulyana Trafimovich3060bb92020-07-16 14:17:11 +0000677 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100678 guess_host_arch_name
David Srbecky928d28e2020-04-01 17:50:51 +0100679 run_args+=(--boot "${ANDROID_HOST_OUT}/apex/com.android.art/javalib/boot.art")
Andreas Gampe11410de2019-07-02 15:53:53 -0700680 run_args+=(--runtime-option "-Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}")
Jeff Hao201803f2013-11-20 18:11:39 -0800681 else
David Brazdil853a4c32015-09-28 16:15:50 +0100682 guess_target_arch_name
Andreas Gampe11410de2019-07-02 15:53:53 -0700683 run_args+=(--runtime-option "-Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}")
David Srbecky928d28e2020-04-01 17:50:51 +0100684 run_args+=(--boot "/apex/com.android.art/javalib/boot.art")
Jeff Hao201803f2013-11-20 18:11:39 -0800685 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700686 if [ "$relocate" = "yes" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700687 run_args+=(--relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700688 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700689 run_args+=(--no-relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700690 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700691elif [ "$runtime" = "jvm" ]; then
692 # TODO: Detect whether the host is 32-bit or 64-bit.
Andreas Gampe11410de2019-07-02 15:53:53 -0700693 run_args+=(--runtime-option "-Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700694fi
695
Alex Light03a112d2014-08-25 13:25:56 -0700696if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700697 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700698 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700699 exit 1
700 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700701 run_args+=(--no-image)
Alex Light03a112d2014-08-25 13:25:56 -0700702fi
703
Alex Light8d94ddd2019-12-18 11:13:03 -0800704if [ "$create_runner" = "yes" -a "$target_mode" = "yes" ]; then
705 err_echo "--create-runner does not function for non --host tests"
706 usage="yes"
707fi
708
jeffhao5d1ac922011-09-29 17:41:15 -0700709if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700710 err_echo "--dev and --update are mutually exclusive"
711 usage="yes"
712fi
713
714if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
715 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700716 usage="yes"
717fi
718
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700719if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
720 err_echo "--bisection-search and --prebuild are mutually exclusive"
721 usage="yes"
722fi
723
Roland Levillain76cfe612017-10-30 13:14:28 +0000724# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
725if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
726 err_echo "--chroot with --bisection-search is unsupported"
727 exit 1
728fi
729
jeffhao5d1ac922011-09-29 17:41:15 -0700730if [ "$usage" = "no" ]; then
731 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
732 test_dir=`basename "$oldwd"`
733 else
734 test_dir="$1"
735 fi
736
737 if [ '!' -d "$test_dir" ]; then
738 td2=`echo ${test_dir}-*`
739 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700740 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700741 usage="yes"
742 fi
743 test_dir="$td2"
744 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700745 # Shift to get rid of the test name argument. The rest of the arguments
746 # will get passed to the test run.
747 shift
748fi
749
750if [ "$usage" = "yes" ]; then
751 prog=`basename $prog`
752 (
753 echo "usage:"
754 echo " $prog --help Print this message."
755 echo " $prog [options] [test-name] Run test normally."
756 echo " $prog --dev [options] [test-name] Development mode" \
757 "(dumps to stdout)."
Alex Light8d94ddd2019-12-18 11:13:03 -0800758 echo " $prog --create-runner [options] [test-name]"
759 echo " Creates a runner script for use with other " \
760 "tools (e.g. parallel_run.py)."
761 echo " The script will only run the test portion, and " \
762 "share oat and dex files."
jeffhao5d1ac922011-09-29 17:41:15 -0700763 echo " $prog --update [options] [test-name] Update mode" \
764 "(replaces expected.txt)."
765 echo ' Omitting the test name or specifying "-" will use the' \
766 "current directory."
767 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000768 echo " -O Run non-debug rather than debug build (off by default)."
769 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000770 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000771 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800772 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700773 echo " --debug Wait for the default debugger to attach."
774 echo " --debug-agent <agent-path>"
775 echo " Wait for the given debugger agent to attach. Currently"
776 echo " only supported on host."
777 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
778 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700779 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000780 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000781 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lighte4b4a182019-02-12 14:19:49 -0800782 echo " --gdbserver Start gdbserver (defaults to port :5039)."
783 echo " --gdbserver-port <port>"
784 echo " Start gdbserver with the given COMM (see man gdbserver)."
785 echo " --gdbserver-bin <binary>"
786 echo " Use the given binary as gdbserver."
787 echo " --gdb-arg Pass an option to gdb or gdbserver."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000788 echo " --build-only Build test files only (off by default)."
789 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800790 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000791 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000792 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700793 echo " --verify-soft-fail Force soft fail verification (off by default)."
794 echo " Verification is enabled if neither --no-verify"
795 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000796 echo " --no-optimize Turn off optimization (on by default)."
797 echo " --no-precise Turn off precise GC (on by default)."
798 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700799 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000800 echo " other runtime options are ignored."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000801 echo " --prebuild Run dex2oat on the files before starting test. (default)"
802 echo " --no-prebuild Do not run dex2oat on the files before starting"
803 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700804 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000805 echo " --relocate Force the use of relocating in the test, making"
806 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000807 echo " address before running."
808 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700809 echo " --image Run the test using a precompiled boot image. (default)"
810 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000811 echo " --host Use the host-mode virtual machine."
812 echo " --invoke-with Pass --invoke-with option to runtime."
813 echo " --dalvik Use Dalvik (off by default)."
814 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700815 echo " --use-java-home Use the JAVA_HOME environment variable"
816 echo " to find the java compiler and runtime"
817 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000818 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700819 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000820 echo " --64 Run the test in 64-bit mode"
Alex Light680cbf22018-10-31 11:00:19 -0700821 echo " --bionic Use the (host, 64-bit only) linux_bionic libc runtime"
Alex Light20802ca2018-12-05 15:36:03 -0800822 echo " --runtime-zipapex [file]"
823 echo " Use the given zipapex file to provide runtime binaries"
Alex Light6f342dd2019-03-27 17:15:42 +0000824 echo " --runtime-extracted-zipapex [dir]"
825 echo " Use the given extracted zipapex directory to provide"
826 echo " runtime binaries"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100827 echo " --timeout n Test timeout in seconds"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000828 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700829 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700830 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000831 echo " --gcstress Run with gc stress testing"
832 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700833 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700834 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700835 echo " --jvmti-redefine-stress"
836 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000837 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700838 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000839 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000840 echo " --android-root [path] The path on target for the android root. (/system by default)."
Victor Chang64611242019-07-05 16:32:41 +0100841 echo " --android-i18n-root [path]"
842 echo " The path on target for the i18n module root."
843 echo " (/apex/com.android.i18n by default)."
Martin Stjernholme58624f2019-09-20 15:53:40 +0100844 echo " --android-art-root [path]"
845 echo " The path on target for the ART module root."
Martin Stjernholmd6be5da2019-07-16 17:14:46 +0100846 echo " (/apex/com.android.art by default)."
Roland Levillain90b34572019-06-14 15:23:15 +0100847 echo " --android-tzdata-root [path]"
848 echo " The path on target for the Android Time Zone Data root."
849 echo " (/apex/com.android.tzdata by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000850 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700851 echo " --instruction-set-features [string]"
852 echo " Set instruction-set-features for compilation."
Alex Light91de25f2015-10-28 17:00:06 -0700853 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700854 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000855 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800856 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700857 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700858 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700859 exit 1
860fi
861
862cd "$test_dir"
863test_dir=`pwd`
864
865td_info="${test_dir}/${info}"
866td_expected="${test_dir}/${expected}"
867
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700868if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700869 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700870 exit 1
871fi
872
873if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700874 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700875 exit 1
876fi
877
878# copy the test to a temp dir and run it
879
Elliott Hughes510c8782011-10-06 10:57:34 -0700880echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700881
882rm -rf "$tmp_dir"
Alex Light0aa7a5a2018-10-10 15:58:14 +0000883cp -LRp "$test_dir" "$tmp_dir"
jeffhao5d1ac922011-09-29 17:41:15 -0700884cd "$tmp_dir"
885
886if [ '!' -r "$build" ]; then
887 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800888else
889 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700890fi
891
892if [ '!' -r "$run" ]; then
893 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800894else
895 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700896fi
897
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700898if [ '!' -r "$check_cmd" ]; then
899 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800900else
901 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700902fi
903
jeffhao5d1ac922011-09-29 17:41:15 -0700904chmod 755 "$build"
905chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700906chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700907
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700908export TEST_NAME=`basename ${test_dir}`
909
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000910# Tests named '<number>-checker-*' will also have their CFGs verified with
911# Checker when compiled with Optimizing on host.
912if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffray8c41a0b2020-02-06 16:52:11 +0000913 if [ "$runtime" = "art" -a "$run_optimizing" = "true" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000914 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
915 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
916 run_checker="yes"
917
Ulyana Trafimovich3060bb92020-07-16 14:17:11 +0000918 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000919 cfg_output_dir="$tmp_dir"
920 checker_args="--arch=${host_arch_name^^}"
921 else
922 cfg_output_dir="$DEX_LOCATION"
923 checker_args="--arch=${target_arch_name^^}"
924 fi
925
926 if [ "$debuggable" = "yes" ]; then
927 checker_args="$checker_args --debuggable"
928 fi
929
Andreas Gampe11410de2019-07-02 15:53:53 -0700930 run_args+=(-Xcompiler-option "--dump-cfg=$cfg_output_dir/$cfg_output" -Xcompiler-option -j1)
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000931 fi
932 fi
933fi
934
Andreas Gampe11410de2019-07-02 15:53:53 -0700935run_args+=(--testlib "${testlib}")
Mathieu Chartier031768a2015-08-27 10:25:02 -0700936
Alex Light20802ca2018-12-05 15:36:03 -0800937if ! ulimit -f ${file_ulimit}; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000938 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700939fi
940
Igor Murashkin2de6e082018-02-28 15:25:23 -0800941# Tell the build script which mode (target, host, jvm) we are building for
942# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000943if [[ "$target_mode" == "yes" ]]; then
944 build_args="$build_args --target"
945else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800946 if [[ $runtime == "jvm" ]]; then
947 build_args="$build_args --jvm"
948 else
949 build_args="$build_args --host"
950 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000951fi
952
953if [[ "$dev_mode" == "yes" ]]; then
954 build_args="$build_args --dev"
955fi
956
jeffhao5d1ac922011-09-29 17:41:15 -0700957good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000958good_build="yes"
959good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700960export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700961if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000962 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700963 build_exit="$?"
964 echo "build exit status: $build_exit" 1>&2
965 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800966 echo "${test_dir}: running..." 1>&2
Andreas Gampe11410de2019-07-02 15:53:53 -0700967 "./${run}" "${run_args[@]}" "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700968 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000969
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800970 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000971 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100972 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000973 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100974 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100975 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000976 checker_exit="$?"
977 if [ "$checker_exit" = "0" ]; then
978 good="yes"
979 fi
Alex Light91de25f2015-10-28 17:00:06 -0700980 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000981 else
982 good="yes"
983 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800984 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000985 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700986 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700987elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000988 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700989 build_exit="$?"
990 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800991 echo "${test_dir}: running..." 1>&2
Andreas Gampe11410de2019-07-02 15:53:53 -0700992 "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000993 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100994 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000995 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100996 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100997 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000998 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700999 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
1000 good="yes"
1001 else
Alex Light91de25f2015-10-28 17:00:06 -07001002 cat "$build_output" 1>&${real_stderr} 1>&2
1003 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -07001004 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001005elif [ "$build_only" = "yes" ]; then
1006 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +00001007 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001008 build_exit="$?"
1009 if [ "$build_exit" '!=' '0' ]; then
1010 cp "$build_output" "$output"
1011 echo "build exit status: $build_exit" >>"$output"
1012 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
1013 if [ "$?" '!=' "0" ]; then
1014 good="no"
Alex Light91de25f2015-10-28 17:00:06 -07001015 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001016 fi
1017 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -07001018 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -07001019 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001020 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -07001021else
David Brazdil4846d132015-01-15 19:07:08 +00001022 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -07001023 build_exit="$?"
1024 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -08001025 echo "${test_dir}: running..." 1>&2
Andreas Gampe11410de2019-07-02 15:53:53 -07001026 "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001027 run_exit="$?"
1028 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -07001029 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001030 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +00001031 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001032 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001033 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001034 fi
David Brazdil5cc343d2015-10-08 11:35:32 +01001035 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +00001036 checker_exit="$?"
1037 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -07001038 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +00001039 good_run="no"
1040 else
1041 good_run="yes"
1042 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001043 else
1044 good_run="yes"
1045 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001046 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001047 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -07001048 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -07001049 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
1050 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -07001051 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -07001052 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -07001053 max_name_length=$(getconf NAME_MAX ${tmp_dir})
1054 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
1055 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -07001056 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -07001057 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -07001058 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -07001059 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001060 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
1061 # output == expected
1062 good="yes"
1063 echo "${test_dir}: succeeded!" 1>&2
1064 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001065 fi
1066fi
1067
jeffhao5d1ac922011-09-29 17:41:15 -07001068(
Alex Lightbfac14a2014-07-30 09:41:21 -07001069 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -07001070 echo "${test_dir}: FAILED!"
1071 echo ' '
1072 echo '#################### info'
1073 cat "${td_info}" | sed 's/^/# /g'
1074 echo '#################### diffs'
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001075 if [ "$run_checker" == "yes" ]; then
1076 # Checker failures dump the whole CFG, so we output the whole diff.
1077 diff --strip-trailing-cr -u "$expected" "$output"
1078 else
Hans Boehm80dc7dc2020-03-10 15:56:42 -07001079 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 10000
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001080 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001081 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001082 if [ "$strace" = "yes" ]; then
1083 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -07001084 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001085 echo '####################'
1086 fi
Andreas Gampee79ca192017-07-31 10:30:16 -07001087 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
1088 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
1089 # tools used by the given ABI work for both x86 and x86-64.
1090 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
1091 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001092 echo ' '
1093 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001094
Alex Light91de25f2015-10-28 17:00:06 -07001095) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -07001096
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001097# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +00001098# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001099if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
1100 # Bisecting works by skipping different optimization passes which breaks checker assertions.
1101 if [ "$run_checker" == "yes" ]; then
1102 echo "${test_dir}: not bisecting, checker test." 1>&2
1103 else
1104 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001105 echo "${test_dir}: bisecting..." 1>&2
1106 cwd=`pwd`
1107 maybe_device_mode=""
1108 raw_cmd=""
1109 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001110 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001111 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1112 # to exec in order to preserve pid when calling dalvikvm. This is required
1113 # for bisection search to correctly retrieve logs from device.
Andreas Gampe11410de2019-07-02 15:53:53 -07001114 "./${run}" "${run_args[@]}" --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001115 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001116 maybe_device_mode="--device"
1117 raw_cmd="$DEX_LOCATION/cmdline.sh"
1118 else
Andreas Gampe11410de2019-07-02 15:53:53 -07001119 raw_cmd="$cwd/${run} --external-log-tags "${run_args[@]}" $@"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001120 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001121 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001122 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1123 $maybe_device_mode \
1124 --raw-cmd="$raw_cmd" \
1125 --check-script="$cwd/check" \
1126 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001127 --logfile="$cwd/bisection_log.txt" \
Martin Stjernholm4815e722019-09-24 16:20:09 +01001128 --timeout=${timeout:-300}
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001129 fi
1130fi
1131
Alex Lightbfac14a2014-07-30 09:41:21 -07001132# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001133if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001134 cd "$oldwd"
1135 rm -rf "$tmp_dir"
1136 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001137 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001138 fi
1139 if [ "$good" = "yes" ]; then
1140 exit 0
1141 fi
1142fi
1143
1144
1145(
1146 if [ "$always_clean" = "yes" ]; then
1147 echo "${TEST_NAME} files deleted from host "
1148 if [ "$target_mode" == "yes" ]; then
1149 echo "and from target"
1150 fi
1151 else
1152 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1153 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001154 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001155 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001156 fi
1157
Alex Light91de25f2015-10-28 17:00:06 -07001158) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001159
Alex Light6a870fa2016-05-31 16:36:19 -07001160if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1161 exit 0
1162else
1163 exit 1
1164fi